#include "graphic.h"

#define REPEAT_DELAY      1000
#define REPEAT_INTERVAL   1000

SDL_Surface *screen = NULL;
int sdl_initialized = 0;
int screen_width = 1024;
int screen_height = 768;
int fullscreen = 0;

// HUD hud;

void reshape_gl()
{
  glViewport(0, 0, (GLsizei)(screen_width), (GLsizei)(screen_height));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  gluPerspective(45.0f, (GLfloat)(screen_width)/(GLfloat)(screen_height), 1.0f, 200.0f);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void init_gl()
{
  glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
  glClearDepth(1.0f);
  glDepthFunc(GL_LEQUAL);
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

void init_sdl()
{
  int flags;
  
  if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO) < 0 )
    fatal_error("Impossible d'initialiser SDL: %s\n", SDL_GetError());
  
  if (SDL_EnableKeyRepeat(REPEAT_DELAY, REPEAT_INTERVAL) == -1)
  {
    printf("Cannot set key repeat to %d, %d\n", REPEAT_DELAY, REPEAT_INTERVAL);
  }
  
  sdl_initialized = 1;

  flags = 0;
  flags |= SDL_HWSURFACE;
  flags |= SDL_OPENGLBLIT;
  if (fullscreen)
    flags |= SDL_FULLSCREEN;
  
  SDL_WM_SetCaption("Just a little music box for few groove", NULL);
  screen = SDL_SetVideoMode(screen_width, screen_height, 32, flags);
  if (!screen)
    fatal_error("Unable to set video mode");
  
  SDL_FillRect(screen, NULL, SDL_MapRGBA(screen->format, 0, 0, 0, 0));
  
  SDL_ShowCursor(SDL_DISABLE);

  reshape_gl();

  init_gl();
}

draw_sphere()
{
  /*gluSphere
      (	GLUquadric* quad
      , GLdouble radius
      , GLint slices
          , GLint stacks
      );*/
}

// draw_icon(Icon *icon,
//            float box_origin_x, float box_origin_y, float box_origin_y,
//            float box_end_x, float box_end_y, float box_end_z,
//            Shape shape)
// {
//   switch (shape)
//   {
//     case BOX:
//       break;
//     case SPHERE:
//       draw_sphere();
//       break;
//     case PYRAMID:
//       break;
//     case CYLINDER:
//       break;
//     case STAR:
//       break;
//   }
// }

void init_graphic_system()
{
 init_sdl();
 
 /*
 Point3  position;
 Box     size;
 Shape   shape;
 */
 
//  draw_icon(&hud.bass[0],
//              0.0f, 0.0f, 0.0f,
//              0.0f, 0.5f, 0.5f,
//              SHPERE
//           );
}

void update_graphic_system()
{
  SDL_GL_SwapBuffers();
}

void shutdown_graphic_system()
{
  if (sdl_initialized)
  {
    SDL_ShowCursor(SDL_ENABLE);
    SDL_Quit();
  }
}

void toggle_fullscreen()
{
  SDL_WM_ToggleFullScreen(screen);
}

void clear_screen()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
}
