#include "wiimote.h"
#include "timer.h"
#include "tools.h"
#include "controller.h"
#include <SDL/SDL_thread.h>
#include <SDL/SDL_thread.h>

#define MAX_WIIMOTES 1

wiimote** wiimotes = NULL;
wiimote *wiimote1 = NULL;
static int connected_wiimotes = 0;

static SDL_Thread *thread;
static SDL_mutex *mutex;

int connect_thread(void *data);

void init_wiimote()
{
  //wiiuse_set_bluetooth_stack(wiimotes, MAX_WIIMOTES, WIIUSE_STACK_BLUESOLEIL); 
  mutex = SDL_CreateMutex();
  thread = SDL_CreateThread(connect_thread, NULL);
}

void shutdown_wiimote()
{
  wiiuse_cleanup(wiimotes, MAX_WIIMOTES);
}

void connect_wiimotes()
{
  int found = 0;
  int i;
  int connected;
  wiimote** wiimotes_found;
  
  wiimotes_found = wiiuse_init(MAX_WIIMOTES);
  
  printf("press 1+2 on the wiimote...\n");
  found = wiiuse_find(wiimotes_found, MAX_WIIMOTES, 5); 
  printf("%d wiimote(s) found\n", found);
  
  if (found)
  {
    connected = wiiuse_connect(wiimotes_found, MAX_WIIMOTES);
    if (connected)
    {
      printf("Connected to %i wiimotes (of %i found).\n", connected, found);
      
      for (i=0; i<MAX_WIIMOTES; i++)
      {
        wiiuse_motion_sensing(wiimotes_found[i], 1);
        wiiuse_toggle_rumble(wiimotes_found[i]);
      }
      SDL_Delay(500);
      for (i=0; i<MAX_WIIMOTES; i++)
      {
        wiiuse_toggle_rumble(wiimotes_found[i]);
      }
    
      SDL_mutexP(mutex);
      connected_wiimotes = connected;
      wiimotes = wiimotes_found;
      SDL_mutexV(mutex);
    }
  }
}

int connect_thread(void *data)
{
  while (connected_wiimotes < 1)
  {
    SDL_Delay(300);
    connect_wiimotes();
  }
}

void update_wiimote()
{
  int i;
  struct wiimote_t *wiimote;
  int has_wiimote = 0;
  
  SDL_mutexP(mutex);
  if (connected_wiimotes != 0)
  {
    has_wiimote = 1;
    wiimote1 = wiimotes[0];
  }
  SDL_mutexV(mutex);
  if (!has_wiimote)
    return;

  while (wiiuse_poll(wiimotes, MAX_WIIMOTES))
  {
    for (i = 0; i < MAX_WIIMOTES; ++i)
    {
      wiimote = wiimotes[i];
      
      switch (wiimote->event)
      {
        case WIIUSE_EVENT:
          /*
          x = wiimote->gforce.z;
          y = wiimote->gforce.y;
          z = wiimote->gforce.x;
          
          wiimote_b = IS_PRESSED(wiimote, WIIMOTE_BUTTON_B);
          wiimote_a = IS_PRESSED(wiimote, WIIMOTE_BUTTON_A);
          */
          
          wiimote_event(wiimote);
          break;
          
        default:
          break;
      }
    }
  }
}

int wiimote_requested_exit()
{
  return (wiimote1 && IS_PRESSED(wiimote1, WIIMOTE_BUTTON_HOME));
}
